##self.m = self.zab.renumber()
	self.m = self.nzaber
        print self.m 
        # set acceleration limits on aperture array and prism stages
        self.zab.command(7,41,255)
        self.zab.command(7,42,180)
        self.zab.command(8,41,255)
        self.zab.command(8,42,180)
        
        # set extension limits on all
        self.zab.command(7,44,560000)
        self.zab.command(8,44,560000)
        
        for i in range(6):
            self.zab.command(i+1,44,210000)

        #add command to limit actuators
            
        self.actuator = 1
				
        #joystick for moving mirror in and out
		
        self.zaber_joystick_table = gtk.Table(10,3,False)
        self.zaber_in_z_button = []
        self.zaber_out_z_button = []
        for i in range(8):
            self.zaber_in_z_button.append(self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN))
            self.zaber_in_z_button[i].connect('clicked', self.zaber_move, 'IN', i+1)
            self.zaber_joystick_table.attach(self.zaber_in_z_button[i],i+1,i+2,0,1,\
                                             xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
            self.zaber_out_z_button.append(self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN))
            self.zaber_out_z_button[i].connect('clicked',self.zaber_move,'OUT', i+1)
            self.zaber_joystick_table.attach(self.zaber_out_z_button[i],i+1,i+2,2,3,\
                                             xoptions = False,yoptions = False,xpadding = 2, \
                                             ypadding = 2)

        #add labels to joystick buttons
	self.zaber_z_label = []
        lbl = ['IR1', 'IR2', 'IR3', 'IR4', 'IR5', 'IR6', 'Pr1', 'Pr2']
        for i in range(len(lbl)):
            self.zaber_z_label.append(gtk.Label(lbl[i]))
            self.zaber_z_label[i].show()
            self.zaber_joystick_table.attach(self.zaber_z_label[i],i+1,i+2,1,2,xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
        
        self.zaber_jst_label = []
        lbl = ['In', 'Out', 'OPD -', 'OPD +']
        xy = [[9,10,0,1], [9,10,2,3], [0,1,0,1], [0,1,2,3]]
        for i in range(len(lbl)):
            self.zaber_jst_label.append(gtk.Label(lbl[i]))
            self.zaber_jst_label[i].show()
            self.zaber_joystick_table.attach(self.zaber_jst_label[i],xy[i][0],xy[i][1],xy[i][2],\
                                             xy[i][3],xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)

        #add menus:
        self.zaber_menu_bar = []
        self.zaber_menu_name = []
        self.zaber_menu = []
        self.zaber_menu_item_home = []
        self.zaber_menu_item_good = []
        self.zaber_menu_item_other = []
        act = [1, 6, 2, 5, 3, 4, 7, 8]
        for i in range(8):
            self.zaber_menu_bar.append(gtk.MenuBar())
            self.zaber_menu_bar[i].show()
            self.zaber_menu_name.append(gtk.MenuItem('Menu'))
            self.zaber_menu_name[i].show()
            self.zaber_menu.append(gtk.Menu())
            self.zaber_menu_item_home.append(gtk.MenuItem('Home'))
            self.zaber_menu_item_good.append(gtk.MenuItem('Good'))
            self.zaber_menu_item_other.append(gtk.MenuItem('Other'))
            self.zaber_menu_item_home[i].show()
            self.zaber_menu_item_good[i].show()
            self.zaber_menu_item_other[i].show()
            self.zaber_menu[i].append(self.zaber_menu_item_home[i])
            self.zaber_menu[i].append(self.zaber_menu_item_good[i])
            self.zaber_menu[i].append(self.zaber_menu_item_other[i])
            self.zaber_menu_item_home[i].connect("activate", self.zaber_home, act[i])
            self.zaber_menu_item_good[i].connect_object("activate", self.zaber_read_file, act[i], 'good.eal')
            self.zaber_menu_item_other[i].connect_object("activate", self.zaber_read_file, act[i], 'other.eal')
            self.zaber_menu_name[i].set_submenu(self.zaber_menu[i])
            self.zaber_menu_bar[i].append(self.zaber_menu_name[i])
            self.zaber_joystick_table.attach(self.zaber_menu_bar[i],\
                                             i+1,i+2,3,4, xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
        self.zaber_joystick_table.show()
        
        #attach joystick table to notebook table
        self.zaber_table.attach(self.zaber_joystick_table,0,2,0,1,xoptions = False|True,\
                                yoptions = False|True)		
        
        #now add 'spin buttons' to select step size of zaber z motion
				
        #now for z, left button does 0.1 microns, right does 10
        self.zaber_z_adjustment = gtk.Adjustment(value=10., lower=0.1, upper=500.0, \
                                                 step_incr=0.1, page_incr=5, page_size=0)
        self.zaber_z_spin_button = gtk.SpinButton(adjustment=self.zaber_z_adjustment, \
                                                  climb_rate=0.0, digits=1)
        #constrain entered values to numbers (not letters)
        self.zaber_z_spin_button.set_numeric(numeric=True)
        #do not wrap from 100 microns to 0.
        self.zaber_z_spin_button.set_wrap(wrap=False)
        #if user enters a non-multiple of 0.1, the number is rounded off
        self.zaber_z_spin_button.set_snap_to_ticks(snap_to_ticks=True)
        #only change the value entered if it is a number within range
        self.zaber_z_spin_button.set_update_policy(gtk.UPDATE_IF_VALID)
        self.zaber_z_spin_button.show()
        
        #toggle switch to automatically view cross section
        self.auto_cross_section = 0
        self.auto_cross_section_check = gtk.CheckButton('View cross section after each move')
        self.auto_cross_section_check.show()
        self.auto_cross_section_check.connect("toggled",self.auto_cross_section_toggled)		
        #add these to the zaber_table in it's own table with lables
        self.zaber_spin_button_table = gtk.Table(3,3,False)
        #add spin_table to zaber table
        
        #add spin buttons and lables to spin_table
        self.zaber_spin_button_table.attach(self.zaber_z_spin_button,1,2,0,1,xpadding = 2, \
                                            ypadding = 2)
        
        self.zaber_z_spin_label = gtk.Label('Z step size:')
        self.zaber_z_spin_label.show()
        self.zaber_microns_label = gtk.Label('microns')
        self.zaber_microns_label.show()
        self.zaber_spin_button_table.attach(self.zaber_z_spin_label,0,1,0,1,xpadding = 2, \
                                            ypadding = 2)
        self.zaber_spin_button_table.attach(self.zaber_microns_label,2,3,0,1,xpadding = 2,\
                                            ypadding = 2)
        self.zaber_spin_button_table.show()
        
        self.zaber_spin_button_table.attach(self.auto_cross_section_check,0,3,2,3,\
                                            xoptions = False|True, yoptions = True|True,\
                                            xpadding = 2, ypadding = 2)

        self.zaber_table.attach(self.zaber_spin_button_table,0,1,1,2,xoptions = False,\
                                yoptions = False,xpadding = 2, ypadding = 2)

        #combo box to choose a ealing actuator and enter position directly
        #self.zaber_renumber_button_label = gtk.Label('Renumber')
        self.zaber_renumber_button = gtk.Button('Renumber')
        self.zaber_renumber_button.connect("clicked",self.zaber_renumber_mount)
        #self.zaber_renumber_button_label.show()
        self.zaber_renumber_button.show()
        
        self.zaber_home_all_button = gtk.Button('Home All')
        self.zaber_home_all_button.show()
        self.zaber_home_all_button.connect("clicked", self.zaber_home, 0)

        self.zaber_restart_button = gtk.Button('Restart')
        self.zaber_restart_button.show()
        self.zaber_restart_button.connect("clicked",self.zaber_restart_mounts)
        
        self.zaber_save_position_button = gtk.Button('Save all positions to file')
        self.zaber_save_position_button.connect("clicked",self.zaber_save_pos)
        self.zaber_save_position_button.show()
		
        self.zaber_recall_position_button = gtk.Button('Recall all positions from file')
        self.zaber_recall_position_button.connect("clicked",self.zaber_recall_pos)
        self.zaber_recall_position_button.show()
        
        #create a table for buttons
        self.zaber_position_button_table = gtk.Table(1,6,False)
        self.zaber_position_button_table.show()
        
        self.zaber_position_button_table.attach(self.zaber_home_all_button,0,1,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_renumber_button,1,2,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_save_position_button,2,3,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_recall_position_button,3,4,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_restart_button,5,6,0,1,\
                                                xpadding = 2, ypadding = 2)		

        self.zaber_table.attach(self.zaber_position_button_table,0,2,2,3,\
                                xoptions = False|True,yoptions = False|True,\
                                xpadding = 2, ypadding = 2)

        #combo_box to choose ealing mount
        self.zaber_combo_box = gtk.combo_box_new_text()
        self.zaber_combo_box.show()
        self.zaber_combo_box.set_wrap_width(1)
        for i in range(6):#self.m):
            self.zaber_combo_box.append_text('Ealing IR%d' % (i+1))
        self.zaber_combo_box.append_text('Aperture array')
        self.zaber_combo_box.append_text('Prism stage')
		
        self.zaber_combo_box.set_active(self.actuator-1)
        self.zaber_combo_box.connect("changed",self.zaber_menu_changed)
        
        #create another table
        self.zaber_direct_move_table = gtk.Table(2,2,False)
        self.zaber_direct_move_table.show()

        #text box to hold position
        self.zaber_position_entry = gtk.Entry(max=6)
        self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))
        self.zaber_position_entry.show()

        self.zaber_move_to_position_button = gtk.Button('Move to')
        self.zaber_move_to_position_button.connect("clicked",self.zaber_move_to_pos)
        self.zaber_move_to_position_button.show()
        
        self.zaber_refresh_position_button = gtk.Button('Refresh')
        self.zaber_refresh_position_button.connect("clicked",self.zaber_refresh_pos)
        self.zaber_refresh_position_button.show()
		
        self.zaber_direct_move_table.attach(self.zaber_combo_box,0,1,0,1,\
                                            xoptions = False|True,yoptions = False|True,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_position_entry,0,1,1,2,\
                                            xoptions = False|True,yoptions = False|True,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_move_to_position_button,1,2,0,1,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_refresh_position_button,1,2,1,2,\
                                            xpadding = 2, ypadding = 2)

        self.zaber_table.attach(self.zaber_direct_move_table,1,2,1,2,xoptions = False|True,\
                                yoptions = False|True,xpadding = 2, ypadding = 2)

       
    #move zaber function
    def zaber_move(self,widget,direction,actuator):
        zz = long(self.zaber_z_spin_button.get_value())
        act = [{'IN':[1, -10*zz], 'OUT':[1,  10*zz]},
               {'IN':[6,  10*zz], 'OUT':[6, -10*zz]},
               {'IN':[2, -10*zz], 'OUT':[2,  10*zz]},
               {'IN':[5,  10*zz], 'OUT':[5, -10*zz]},
               {'IN':[3, -10*zz], 'OUT':[3,  10*zz]},
               {'IN':[4,  10*zz], 'OUT':[4, -10*zz]},
               {'IN':[7,  10*zz], 'OUT':[7, -10*zz]},
               {'IN':[8,  10*zz], 'OUT':[8, -10*zz]}]
        self.zab.move_relative(act[actuator-1][direction][0], 1, act[actuator-1][direction][1])
        self.zaber_refresh_pos(0)
            
        if (self.auto_cross_section):
            self.view_cross_section(0)
	

    #functions for saving current position to a file
    def zaber_save_pos(self,widget):		
        self.zaber_save_filew = gtk.FileSelection('Save all positions to file')
        self.zaber_save_filew.connect("destroy",lambda w: self.zaber_save_filew.destroy())
        self.zaber_save_filew.ok_button.connect("clicked",self.zaber_file_save_action)
        self.zaber_save_filew.cancel_button.connect("clicked",lambda w: \
                                                    self.zaber_save_filew.destroy())
        self.zaber_save_filew.show()

    #function to actually do the filesaving
    def zaber_file_save_action(self,widget):
        self.zab.save_position(self.zaber_save_filew.get_filename(),self.m)
        print "save info to %s" % self.zaber_save_filew.get_filename()
        self.zaber_save_filew.destroy()

    #functions for recalling position from a file
    def zaber_recall_pos(self,widget):
        self.zaber_recall_filew = gtk.FileSelection('Recall all positions from file')
        self.zaber_recall_filew.connect("destroy",lambda w: self.zaber_recall_filew.destroy())
        self.zaber_recall_filew.ok_button.connect("clicked",self.zaber_file_recall_action)
        self.zaber_recall_filew.cancel_button.connect("clicked",\
                                                      lambda w: self.zaber_recall_filew.destroy())
        self.zaber_recall_filew.show()
                
    #function that actually recalls the file
    def zaber_file_recall_action(self,widget):
        self.zab.recall_position(self.zaber_recall_filew.get_filename(),self.m)
        print "recalled info from %s" % self.zaber_recall_filew.get_filename()
        self.zaber_recall_filew.destroy()		
			
    def zaber_renumber_mount(self,widget):            
        print 'renumbering mounts '
        self.nzaber = self.zab.renumber()
	print "self.nzaber = ", self.nzaber
				
    def zaber_restart_mounts(self,widget):
        self.zab.restart()
        self.zab.renumber_mount(0)		

    def zaber_home(self,widget,actuator):
        print 'actuator = ', actuator	
        self.zab.home(actuator, 1)
        self.zaber_refresh_pos(0)

    def zaber_read_file(self,actuator, filename):
        file = open(filename)
        text = file.read()
        positions = text.split("\n")
        self.zab.move_absolute(actuator, 1, long(positions[actuator-1]))
        self.zaber_refresh_pos(0)

    def auto_cross_section_toggled(self,widget):
        self.auto_cross_section = self.auto_cross_section_check.get_active()		

    #function for combo box to enter/see exact postion of ealing actuator:
    def zaber_menu_changed(self,combo_box):
	act = [1, 6, 2, 5, 3, 4, 7, 8]
        self.actuator = act[combo_box.get_active()]
				
        #insert function to set text on position box
        self.zaber_refresh_pos(0)

    def zaber_move_to_pos(self,widget):
        self.zab.move_absolute(self.actuator, 1, long(self.zaber_position_entry.get_text()))
        
    def zaber_refresh_pos(self,widget):
        self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))

    def main(self):        
        gtk.main()
